<span>Connected servers</span>
<mat-card [appearance]="'outlined'" class="mb-3">
    <mat-card-content>
        <div class="table-container">
            <table *ngIf="serverInfos.length > 0" mat-table [dataSource]="serverInfos" class="mat-elevation-z8">
                <ng-container matColumnDef="serverName">
                  <th mat-header-cell *matHeaderCellDef>Server name</th>
                  <td mat-cell *matCellDef="let server"> {{server.serverName}} </td>
                </ng-container>
                <ng-container matColumnDef="serverType">
                  <th mat-header-cell *matHeaderCellDef>Server type</th>
                  <td mat-cell *matCellDef="let server"> {{server.serverType}} </td>
                </ng-container>
                <ng-container matColumnDef="serveruuid">
                  <th mat-header-cell *matHeaderCellDef>Server UUID</th>
                  <td mat-cell *matCellDef="let server"> {{server.serveruuid}} </td>
                </ng-container>
                <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
            </table>
        </div>
        <span *ngIf="serverInfos.length == 0">No servers available</span>
    </mat-card-content>
    <mat-card-footer></mat-card-footer>
</mat-card>
<div *ngIf="discoveryProgress == 100" class="mb-3">
    <span>Newly connected servers</span>
    <mat-card [appearance]="'outlined'">
        <mat-card-content>
            <div class="table-container">
                <table *ngIf="newServerInfos.length > 0" mat-table [dataSource]="newServerInfos" class="mat-elevation-z8">
                    <ng-container matColumnDef="serverName">
                        <th mat-header-cell *matHeaderCellDef>Server name</th>
                        <td mat-cell *matCellDef="let server"> {{server.serverName}} </td>
                    </ng-container>
                    <ng-container matColumnDef="serverType">
                        <th mat-header-cell *matHeaderCellDef>Server type</th>
                        <td mat-cell *matCellDef="let server"> {{server.serverType}} </td>
                    </ng-container>
                    <ng-container matColumnDef="serveruuid">
                        <th mat-header-cell *matHeaderCellDef>Server UUID</th>
                        <td mat-cell *matCellDef="let server"> {{server.serveruuid}} </td>
                    </ng-container>
                    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                    <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
                </table>
            </div>
            <span *ngIf="newServerInfos.length == 0 && discoveryProgress == 100">No new servers found</span>
            <span *ngIf="hasNewFeatures">New features were registered (gateway restart required)</span>
        </mat-card-content>
        <mat-card-footer></mat-card-footer>
    </mat-card>
</div>
<app-error-area [hidden]="!errorAreaVisible" [definedExecutionErrors]="[]" class="mb-3"></app-error-area>
<span>Server discovery</span>
<mat-card [appearance]="'outlined'" class="mb-3">
    <mat-card-content>
        <div class="row">
            <div class="col-xl-3">
                <mat-form-field>
                    <mat-label>Timeout</mat-label>
                    <input matInput type="number" [formControl]="discoveryTimeout">
                </mat-form-field>
            </div>
        </div>
        <div> 
            <button mat-raised-button color="primary" (click)="startServerDiscovery()">Start discovery</button>
        </div>
    </mat-card-content>
    <mat-card-footer></mat-card-footer>
</mat-card>
<span>Add server</span>
<mat-card [appearance]="'outlined'" class="mb-3">
    <mat-card-content>
        <div class="row" [formGroup]="addServerFormGroup">
            <div class="col-xl-3">
                <mat-form-field>
                    <mat-label>Host</mat-label>
                    <input matInput type="text" formControlName="host">
                </mat-form-field>
            </div>
            <div class="col-xl-3">
                <mat-form-field>
                    <mat-label>Port</mat-label>
                    <input matInput type="number" formControlName="port">
                </mat-form-field>
            </div>
        </div>
        <div>
            <button mat-raised-button color="primary" (click)="addServer()">Add server</button>
        </div>
    </mat-card-content>
    <mat-card-footer></mat-card-footer>
</mat-card>
<div>
    <mat-progress-bar mode="determinate" [value]="discoveryProgress"></mat-progress-bar>
</div>